/************************************************************************
     File:        main.cpp

     Author:     
                  Richard Yu Gu
									Mike Gleicher, gleicher@cs.wisc.edu
     Modifier
                  Yu-Chi Lai, yu-chi@cs.wisc.edu
     
     Comment:     this class implements a very simple widget that responds to 
		              events the idea is to show how to handle events in fltk
	 
     Platform:    Visio Studio.Net 2005
*************************************************************************/

#include "EventBox.h"

//***********************************************************************
//
// * Constructor
//=======================================================================
EventBox::EventBox(int t, int l, int width, int height)
         :Fl_Box(FL_UP_BOX, t, l, width, height, "")
//=======================================================================
{	
	// Set up the label
	labelfont(FL_ITALIC);

	// Set up the label size
	labelsize(24);

	// Set up the label style
	labeltype(FL_SHADOW_LABEL);

	// Set up text inside the box
	label("Hello");

}

//***********************************************************************
//
// * Handle the event happening in this box
//=======================================================================
int EventBox::handle(int e)
//=======================================================================
{
	switch(e)	{
		case FL_ENTER: // When the cursor enters this box
			// Change the color to red
			color (FL_RED);
			// Change the label to black
			labelcolor(FL_BLACK);
			// Notify window to redraw is needed
			damage(1);
			return 1;
		case FL_LEAVE: // When the cursor leave this box
			// Change the color to gray
			color(FL_GRAY);
			// Change the label to black
			labelcolor(FL_BLACK);
			// Notify window to redraw is needed
			damage(1);
			return 1;
		case FL_PUSH: // When mouse button is pushing
			// Change the color to blue
			labelcolor(FL_BLUE);
			// Notify window to redraw is needed
			damage(1);
			return 1;
		case FL_RELEASE: // When release the mouse button
			// Change the label color to black
			labelcolor(FL_BLACK);
			damage(1);
			return 1;
		case FL_DRAG: // When drag the mouse button
			// Set the label to yellow
			labelcolor(FL_YELLOW);
			damage(1);
			return 1;
		default:
			return Fl_Box::handle(e);
	};

}